﻿Imports System.Configuration
Imports System.Text
Imports System.Threading.Tasks
Imports Microsoft.WindowsAzure.Storage
Imports Microsoft.WindowsAzure.Storage.Auth
Imports Microsoft.WindowsAzure.Storage.Blob

Namespace ImageUploadAndProcessingJob
	Public NotInheritable Class RemoteStorageManager
		Private Shared sourceAccount As CloudStorageAccount
		Private Shared sourceBlobClient As CloudBlobClient
		Private Shared targetAccount As CloudStorageAccount
        Private Shared targetBlobClient As CloudBlobClient

		Private Sub New()
        End Sub

		Shared Sub New()
			If ConfigurationManager.ConnectionStrings("AzureJobsRuntime") IsNot Nothing AndAlso ConfigurationManager.ConnectionStrings("RemoteAzureStorage") IsNot Nothing Then
				sourceAccount = CloudStorageAccount.Parse(ConfigurationManager.ConnectionStrings("AzureJobsRuntime").ConnectionString)
				sourceBlobClient = sourceAccount.CreateCloudBlobClient()
				targetAccount = CloudStorageAccount.Parse(ConfigurationManager.ConnectionStrings("RemoteAzureStorage").ConnectionString)
				targetBlobClient = targetAccount.CreateCloudBlobClient()
			End If
		End Sub

		Public Shared Sub ReplicateBlob(ByVal container As String, ByVal blob As String)
			If sourceBlobClient Is Nothing OrElse targetBlobClient Is Nothing Then
				Return
            End If

			Dim sourceContainer = sourceBlobClient.GetContainerReference(container)
			Dim targetContainer = targetBlobClient.GetContainerReference(container)
			If targetContainer.CreateIfNotExists() Then
				targetContainer.SetPermissions(sourceContainer.GetPermissions())
            End If

			Dim targetBlob = targetContainer.GetBlockBlobReference(blob)
			targetBlob.StartCopyFromBlob(sourceContainer.GetBlockBlobReference(blob))
        End Sub

	End Class
End Namespace
